# Sybil Engine

## Introduction
Sybil Engine is a powerful Python library designed for testing web3 contracts. It facilitates seamless interactions with blockchain networks and smart contracts, providing developers with efficient tools to execute, plan, and manage web3 transactions.

## Key Features
- **Withdrawal Operations**: Simplify withdrawals from OKX to various networks such as Arbitrum One, Base, Linea, and ZKSync.
- **Private Key Management**: Securely read and encrypt private keys from .csv or txt files.
- **Execution Planner**: Strategically plan your contract executions for optimal performance.
- **Module Executor**: Execute modules efficiently with tailored contract interactions.
- **Transaction Executor**: Execute transactions reliably with built-in support for various scenarios.
- **Generic DEX Logic**: Implement generic decentralized exchange logic for versatile blockchain applications.

## Installation
Install Sybil Engine using pip:
```bash
pip install sybil-engine
